; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

		_SAP_HEADER "ANTIC: WSYNC timing"

		opt		h+o+

		icl		'library.s'

		org		$2000

main:
		ldy		#>testname
		lda		#<testname
		jsr		_testInit
		
		jsr		_screenOff
		jsr		_interruptsOff
		
		mva		#$80 audctl
		mva		#0 skctl
		sta		wsync
		lda		#3
		sta		wsync
		sta		skctl
		sta		wsync
		ldy		random			;*, 105, 106, 107
		sty		d0				;108, 109, 110
		nop						;111, 112
		sta		wsync			;113, 0, 1*, 2, 3
		lda		random			;*, 105, 106, 107
		sta		d1				;108, 109, 110
		inc		wsync			;111, 112, 113, 0, 1*, 2, 3
		lda		random
		sta		d2

		;check values
		lda		d0
		cmp		#$95
		beq		test1_ok
		
		sta		d1		
		jsr		_testFailed
		dta		c"Initial RANDOM incorrect: $%x.",0
		
test1_ok:
		lda		d1
		cmp		#$4b
		beq		test2_ok
		
		jsr		_testFailed
		dta		c"STA WSYNC failed: $%x.",0
		
test2_ok:
		lda		d2
		cmp		#$0d
		beq		test3_ok
		
		sta		d1		
		jsr		_testFailed
		dta		c"INC WSYNC failed: $%x.",0

test3_ok:
		jmp		_testPassed

		;set noise generator to long mode and read a byte
		
testname:
		dta		c"ANTIC: WSYNC timing",0

		run		$2000
		end
